﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms
Imports System.Drawing.Drawing2D
Imports Syncfusion.Windows.Forms.Tools

Namespace CarouselDemo_2008
	Partial Public Class Form1
		Inherits MetroForm
		Private allowRotate As Boolean = False
		Public Sub New()
			InitializeComponent()
			SetInitializationSettings()

			Try
                Dim ico As New System.Drawing.Icon(GetIconFile("common\Images\Grid\Icon\sfgrid.ico"))
				Me.Icon = ico
			Catch
			End Try
		End Sub

		Private Function GetIconFile(ByVal bitmapName As String) As String
			For n As Integer = 0 To 9
				If System.IO.File.Exists(bitmapName) Then
					Return bitmapName
				End If

				bitmapName = "..\" & bitmapName
			Next n

			Return bitmapName
		End Function


		Private Sub SetInitializationSettings()
			Me.comboPath.SelectedItem = "Default"
			Me.chkRotate.Checked = Me.carousel1.RotateAlways
			Me.trkPersp.Value = CInt(Fix(Me.carousel1.Perspective))
			Me.trkSpeed.Value = CInt(Fix(Me.carousel1.TransitionSpeed))
			Me.chkShadow.Checked = Me.carousel1.ShowImageShadow
			Me.chkPreview.Checked = Me.carousel1.ShowImagePreview
			Me.chkOrig.Checked = Me.carousel1.UseOriginalImageinPreview
			Me.label1.Text = Me.carousel1.Perspective.ToString()
			Me.label2.Text = Me.carousel1.TransitionSpeed.ToString()
		End Sub

		Private Sub trkPersp_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles trkPersp.ValueChanged
			Me.carousel1.Perspective = Me.trkPersp.Value
			Me.label1.Text = Me.carousel1.Perspective.ToString()
			Me.carousel1.Refresh()

		End Sub

		Private Sub trkSpeed_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles trkSpeed.ValueChanged
			Me.carousel1.TransitionSpeed = Me.trkSpeed.Value
			Me.label2.Text = Me.carousel1.TransitionSpeed.ToString()
			Me.carousel1.Refresh()
		End Sub

		Private Sub chkShadow_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles chkShadow.CheckedChanged
			Me.carousel1.ShowImageShadow = Me.chkShadow.Checked
			Me.carousel1.Refresh()
		End Sub

		Private Sub chkPreview_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles chkPreview.CheckedChanged
			Me.carousel1.ShowImagePreview = Me.chkPreview.Checked
			Me.carousel1.Refresh()
		End Sub

		Private Sub chkOrig_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles chkOrig.CheckedChanged
			Me.carousel1.UseOriginalImageinPreview = Me.chkOrig.Checked
			Me.carousel1.Refresh()
		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			colorDialog1.Color = Color.Empty
			colorDialog1.ShowDialog()
			Me.carousel1.HighlightColor = colorDialog1.Color
			Me.carousel1.Refresh()
		End Sub

		Private Sub button2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button2.Click
			colorDialog1.Color = Color.Empty
			colorDialog1.ShowDialog()
			Me.carousel1.ImageshadeColor = colorDialog1.Color
			Me.carousel1.Refresh()
		End Sub

		Private Sub chkRotate_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles chkRotate.CheckedChanged
			Me.carousel1.RotateAlways = Me.chkRotate.Checked
			Me.chknvr.Enabled = Not Me.chkRotate.Checked
		End Sub

		Private Sub comboPath_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles comboPath.SelectedIndexChanged
			Select Case Me.comboPath.SelectedItem.ToString()
				Case "Orbital"
					Me.carousel1.CarouselPath = CarouselPath.Orbital
					Me.carousel1.PadY = 15
				Case "Linear"
					Me.carousel1.CarouselPath = CarouselPath.Linear
				Case "Oval"
					Me.carousel1.CarouselPath = CarouselPath.Oval
					Me.carousel1.PadY = 15
				Case Else
					Me.carousel1.CarouselPath = CarouselPath.Default
					Me.carousel1.PadY = 0
			End Select
			Me.label1.Text = Me.carousel1.Perspective.ToString()
			Me.label2.Text = Me.carousel1.TransitionSpeed.ToString()
			Me.trkSpeed.Value = CInt(Fix(Me.carousel1.TransitionSpeed))
			Me.trkPersp.Value = CInt(Fix(Me.carousel1.Perspective))
		End Sub

		Private Sub chknvr_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles chknvr.CheckedChanged
			allowRotate = chknvr.Checked
			chkRotate.Enabled = Not chknvr.Checked
		End Sub

		Private Sub carousel1_OnCarouselItemSelectionChanging(ByVal sender As Object, ByVal e As CarouselItemSelectionChangingArgs) Handles carousel1.OnCarouselItemSelectionChanging
			e.Cancel = allowRotate
		End Sub

		Private Sub carousel1_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles carousel1.Paint
			e.Graphics.DrawRectangle(New Pen(Color.Gray), e.ClipRectangle)
		End Sub
	End Class
End Namespace
